<h1 align="center">
    <img width="400" src="logo.png" alt="crayons">
    <br>
</h1>

> Colored and styled strings for terminals.

[![Build Status](https://github.com/KristofferC/Crayons.jl/workflows/CI/badge.svg)](https://github.com/KristofferC/Crayons.jl/actions?query=workflows/CI) [![codecov](https://codecov.io/gh/KristofferC/Crayons.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/KristofferC/Crayons.jl)

*Crayons* is a package that makes it simple to write strings in different colors and styles to terminals.
It supports the 16 system colors, both the 256 color and 24 bit true color extensions, and the different text styles available to terminals.
The package is designed to perform well, have no dependencies and load quickly.


## Installation

```jl
import Pkg; Pkg.add("Crayons")
```

## Usage

### Creating `Crayon`s

A `Crayon` is created with the keyword only constructor:

```julia
Crayon(; foreground = nothing,
         background = nothing,
         reset = nothing,
         bold = nothing,
         faint = nothing,
         italics = nothing,
         underline = nothing,
         blink = nothing,
         negative = nothing,
         conceal = nothing,
         strikethrough = nothing)
```

The `foreground` and `background` arguments support four forms:

* A `Symbol` representing a color.
  The available colors are `black`, `red`, `green`, `yellow`, `blue`, `magenta`, `cyan`, `light_gray`, `default`, `dark_gray`, `light_red`, `light_green`, `light_yellow`, `light_blue`, `light_magenta`, `light_cyan` and `white`.
  To see the colors in action, try `Crayons.test_system_colors()`.
  These colors are supported by almost all terminals.
* An `Integer` between 0 and 255. `UInt32` values are interpreted as hexadecimal RGB colors as described below.
  This will use the 256 color ANSI escape codes.
  To see what number corresponds to what color and if your terminal supports 256 colors, use `Crayons.test_256_colors(codes=true)`.
* A `Tuple` of three `Integer`s, all between 0 and 255.
  This will be interpreted as a `(r, g, b)` 24 bit color.
  To test your terminal's support for 24-bit colors, use `Crayons.test_24bit_colors(codes=false)`.
  The support for this is currently quite limited but is being improved in terminals continuously, see [here](https://gist.github.com/XVilka/8346728).
* A `UInt32` representing a color given in hexadecimal format.
  Will be converted to the corresponding RGB format.

Out-of-range color indices, RGB channels, and hexadecimal values throw an `ArgumentError`.

The other keyword arguments are all of `Bool` type and determine whether the corresponding style should be explicitly enabled or disabled:

* `reset` — reset all styles and colors to default
* `bold` — bold text, also brighten the colors on some terminals
* `faint` — faint text, not widely supported
* `italics` — italic text, not widely supported
* `underline` — underlined text
* `blink` — blinking text
* `negative` — swap the foreground and background
* `conceal`— hides the text, not widely supported
* `strikethrough` — horizontal line through the middle of the text, not widely supported.

To see text with the different styles active, use `Crayons.test_styles()`

By using `nothing` for any of the keyword arguments, that color or style is inactive and is thus neither actively enabled nor disabled.

For convenience, `Crayon`s for the foreground / background version of the 16 system colors as well as the different styles are pre-made and can be found in the `Crayons.Box` module.
They have the name `<COLOR_NAME>_<BG/FG>` for the foreground/background colors and `<STYLE>` for the different styles (note the uppercase).
There is also a `RESET` crayon that resets all colors and styles.
Calling `using` on the `Crayons.Box` module will bring all these into global scope.

#### String macros

`Crayon`s can also be created in a terser way using the [string macro](https://docs.julialang.org/en/stable/manual/metaprogramming/#Non-Standard-String-Literals-1) `crayon`.
These are written using `crayon"[[fg:]<col>] [bg:<col>] ([[!]<style>] ...)"` where:
* text inside a square bracket is optional
* `<col>` is a color given as a hexadecimal number, `(r,g,b)` tuple (no spaces), a number 0-255, or one of the 16 named colors.
* `<style>` is one of the styles.
* `!` means that the style is explicitly disabled.
* `(<style> ...)` means a repeated number of styles, separated by spaces.

A few examples of using the string macros and the equivalent constructor are shown below.

```julia
crayon"red" # Crayon(foreground = :red)
crayon"bg:(255,0,255)" # Crayon(background = (255, 0, 255))
crayon"!bold underline 0xff00ff" # Crayon(bold = false, underline = true, foreground = 0xff00ff)
crayon"#0000ff" # Crayon(foreground = 0x0000ff)
```


### Using the `Crayon`s

The process of printing colored and styled text using *Crayons* is simple.
By printing a `Crayon` to the terminal, the correct code sequences are sent to the terminal such that subsequent printed text takes on the color and style of the printed `Crayon`.
For example, try running the code below in the REPL:

```julia
print(Crayon(foreground = :red), "In red. ", Crayon(bold = true), "Red and bold")
print(Crayon(foreground = 208, background = :red, bold = true), "Orange bold on red")
print(Crayon(negative = true, underline = true, bold = true), "Underlined inverse bold")
print(Crayon(foreground = (100, 100, 255), background = (255, 255, 0)), "Bluish on yellow")

using Crayons.Box
print(GREEN_FG, "This is in green")
print(BOLD, GREEN_FG, BLUE_BG, "Bold green on blue")
```

It is also possible to use *call overloading* on created `Crayon`s.
The `Crayon` can be called with strings and other `Crayon`s and the colors and styles will correctly nest.
Correct end sequences will also be printed so the colors and styles are disabled outside the call scope.
This functionality is perhaps more clearly shown with some examples:


```julia
using Crayons.Box
print(UNDERLINE("This is underlined."), " But this is not")
print(RED_FG("Hello ", BLUE_BG("world"), "!!!"), "!!!")
print(GREEN_BG("We ",
          UNDERLINE("are ",
              MAGENTA_FG("nesting "),
          "some "),
      "colors")
     )
```

A `Crayon` can also be applied to a string with `*`, and the resulting objects concatenate with strings and each other:

```julia
print(crayon"red" * "In red. " * crayon"blue"("In blue. ") * "Normal.")
```

**Note:** In order for the color sequences to be printed, the Julia REPL needs to have colors activated,
either by Julia automatically detecting terminal support or by starting Julia with the `--color=yes` argument.
Alternatively, if the environment variable `FORCE_COLOR` exists, or `Crayons.force_color(::Bool)` has been enabled,
color sequences are printed no matter what. Also, since relatively few terminals support full 24-bit colors,
it is possible to activate 256 color mode which converts the 24-bit crayon to a 256 color crayon when printed.
This is done by either defining the environment variable `FORCE_256_COLORS` or by calling `Crayons.force_256_colors(::Bool)`.
In addition, some systems have problems even with 256 colors. It is possible to convert 24-bit and 256-color crayons to one of the 16 system colors
by defining the variable `FORCE_SYSTEM_COLORS` or by calling `Crayons.force_system_colors(::Bool)`. Note that 16 colors (8 + 8 light versions) is a quite small colorspace so the conversion is unlikely to be very good.
The environment variables are read once when the package is loaded; to change the behavior at runtime, use the `force_*` functions.

If the `IO` object being printed to has the `:color` property set (e.g. via an `IOContext`), that property takes
precedence over the global color setting. This can be used to force escape sequences into a string regardless of
terminal support: `sprint(print, crayon; context = :color => true)`.

## Merging `Crayon`s

Two or more `Crayon`s can be merged resulting in a new `Crayon` with all the properties of the merged ones.
This is done with the function `merge(crayons::Crayon...)` or by multiplying `Crayon`s using `*`.
If two `Crayon`s specify the same property then the property of the last `Crayon` in the argument list is used:
If a later `Crayon` has `reset = true`, earlier properties are cleared before its other properties are applied.

```julia
using Crayons.Box
r_fg = Crayon(foreground = :red)
g_bg = Crayon(background = :green)
merged = merge(r_fg, g_bg)
print(merged, "Red foreground on green background!")
print(r_fg * g_bg * Crayons.Box.BOLD, "Bold Red foreground on green background!")
# Also with call overloading and nesting
print(GREEN_FG(
          "I am a green line ",
          BOLD * BLUE_FG * UNDERLINE(
              "with a bold underlined blue substring"
          ),
          " that becomes green again!"
     ))
```

## Misc

The function `inv` on a `Crayon` returns a `Crayon` that undoes what the `Crayon` in the argument to `inv` does.
As an example, `inv(Crayon(bold = true))` returns a `Crayon` that disables bold.

If a background color is active when a newline is printed, many terminals paint the rest of the next line with
that background ("background color erase"). Print the resetting crayon *before* the newline to avoid this.

Crayons do not survive line breaks in messages passed to the Julia logging system (`@info` etc.), since the
logger emits its own color codes for the prefix of each line. Apply the crayon to each line separately if needed.

## Advanced nesting of colors and styles

If you want to nest colors and styles through function calls there is the `CrayonStack` type.
Simply `push!` `Crayon`s onto the stack, print text to the stack, and then `pop!` the `Crayons` off.
The stack will keep track of what `Crayon` is currently active.
It is used just like a `Crayon`:

```julia
stack = CrayonStack()
print(stack, "normal text")
print(push!(stack, Crayon(foreground = :red)), "in red")
print(push!(stack, Crayon(foreground = :blue)), "in blue")
print(pop!(stack), "in red again")
print(pop!(stack), "normal text")
```
A `CrayonStack` can also be created in `incremental` mode by calling `CrayonStack(incremental = true)`.
In that case, the `CrayonStack` will only print the changes that are needed to go from the previous text state to the new state,
which results in less color codes being printed.
However, note that this means that the `CrayonStack` needs to be printed to the output buffer for **all** changes that are made to it
(i.e. both when `push!` and `pop!` are used).
The example below shows a working example where all the changes to the stack are printed and another example, which gives wrong result,
since one change is not printed.
Both the examples below work correctly if `incremental = false`.

```julia
# Does work
io = IOBuffer()
stack = CrayonStack(incremental = true)
print(io, push!(stack, Crayon(foreground = :red)))
print(io, push!(stack, Crayon(foreground = :red)))
print(io, stack, "This will be red")
print(String(take!(io)))

# Does not work
io = IOBuffer()
stack = CrayonStack(incremental = true)
push!(stack, Crayon(foreground = :red)) # <- not printing the stack even though we modify it!
print(io, push!(stack, Crayon(foreground = :red)))
print(io, stack, "This will not be red")
print(String(take!(io)))
```

The reason why the last example did not work is because the stack notices that there is no change of text state on the second call to `push!`, since the foreground was just kept red.
Failing to print the stack after the first `push!` meant that the terminal state and the stack state got out of sync.

### Related packages:

https://github.com/Aerlinger/AnsiColor.jl

### Author

Kristoffer Carlsson — [@KristofferC](https://github.com/KristofferC)

module Box

using Crayons

export BLACK_FG,
RED_FG,
GREEN_FG,
YELLOW_FG,
BLUE_FG,
MAGENTA_FG,
CYAN_FG,
LIGHT_GRAY_FG,
DEFAULT_FG,
DARK_GRAY_FG,
LIGHT_RED_FG,
LIGHT_GREEN_FG,
LIGHT_YELLOW_FG,
LIGHT_BLUE_FG,
LIGHT_MAGENTA_FG,
LIGHT_CYAN_FG,
WHITE_FG,
BLACK_BG,
RED_BG,
GREEN_BG,
YELLOW_BG,
BLUE_BG,
MAGENTA_BG,
CYAN_BG,
LIGHT_GRAY_BG,
DEFAULT_BG,
DARK_GRAY_BG,
LIGHT_RED_BG,
LIGHT_GREEN_BG,
LIGHT_YELLOW_BG,
LIGHT_BLUE_BG,
LIGHT_MAGENTA_BG,
LIGHT_CYAN_BG,
WHITE_BG,
BOLD,
FAINT,
ITALICS,
UNDERLINE,
BLINK,
NEGATIVE,
CONCEAL,
STRIKETHROUGH,
RESET

const BLACK_FG         = Crayon(foreground = :black         )
const RED_FG           = Crayon(foreground = :red           )
const GREEN_FG         = Crayon(foreground = :green         )
const YELLOW_FG        = Crayon(foreground = :yellow        )
const BLUE_FG          = Crayon(foreground = :blue          )
const MAGENTA_FG       = Crayon(foreground = :magenta       )
const CYAN_FG          = Crayon(foreground = :cyan          )
const LIGHT_GRAY_FG    = Crayon(foreground = :light_gray    )
const DEFAULT_FG       = Crayon(foreground = :default       )
const DARK_GRAY_FG     = Crayon(foreground = :dark_gray     )
const LIGHT_RED_FG     = Crayon(foreground = :light_red     )
const LIGHT_GREEN_FG   = Crayon(foreground = :light_green   )
const LIGHT_YELLOW_FG  = Crayon(foreground = :light_yellow  )
const LIGHT_BLUE_FG    = Crayon(foreground = :light_blue    )
const LIGHT_MAGENTA_FG = Crayon(foreground = :light_magenta )
const LIGHT_CYAN_FG    = Crayon(foreground = :light_cyan    )
const WHITE_FG         = Crayon(foreground = :white         )

const BLACK_BG         = Crayon(background = :black         )
const RED_BG           = Crayon(background = :red           )
const GREEN_BG         = Crayon(background = :green         )
const YELLOW_BG        = Crayon(background = :yellow        )
const BLUE_BG          = Crayon(background = :blue          )
const MAGENTA_BG       = Crayon(background = :magenta       )
const CYAN_BG          = Crayon(background = :cyan          )
const LIGHT_GRAY_BG    = Crayon(background = :light_gray    )
const DEFAULT_BG       = Crayon(background = :default       )
const DARK_GRAY_BG     = Crayon(background = :dark_gray     )
const LIGHT_RED_BG     = Crayon(background = :light_red     )
const LIGHT_GREEN_BG   = Crayon(background = :light_green   )
const LIGHT_YELLOW_BG  = Crayon(background = :light_yellow  )
const LIGHT_BLUE_BG    = Crayon(background = :light_blue    )
const LIGHT_MAGENTA_BG = Crayon(background = :light_magenta )
const LIGHT_CYAN_BG    = Crayon(background = :light_cyan    )
const WHITE_BG         = Crayon(background = :white         )

const BOLD             = Crayon(bold          = true)
const FAINT            = Crayon(faint         = true)
const ITALICS          = Crayon(italics       = true)
const UNDERLINE        = Crayon(underline     = true)
const BLINK            = Crayon(blink         = true)
const NEGATIVE         = Crayon(negative      = true)
const CONCEAL          = Crayon(conceal       = true)
const STRIKETHROUGH    = Crayon(strikethrough = true)

const RESET            = Crayon(reset         = true)

end

function test_styles(io::IO = stdout)
    for style in (:bold,
                  :faint,
                  :italics,
                  :underline,
                  :blink,
                  :negative,
                  :conceal,
                  :strikethrough)
        print(io, Crayon(;style => true), "Printed with $style = true", Crayon(reset = true))
        style == :conceal && print(io, "  <- This is concealed = true")
        println(io)
    end
end

function test_system_colors(io::IO = stdout)
    for col in map(first,sort(collect(COLORS), by=last))
        print(io, Crayon(foreground = col), lpad("$col", 15, ' '), " ", Crayon(reset = true))
        print(io, Crayon(background = col), col, Crayon(reset = true), "\n")
    end
end

test_256_colors(; codes::Bool = true) = test_256_colors(stdout, codes)
test_256_colors(io::IO) = test_256_colors(io, true)
function test_256_colors(io::IO, codes::Bool)
    println(io, "System colors (0..15):")

    for c in 0:15
        str = codes ? string(lpad(c, 3, '0'), " ") : "██"
        print(io, Crayon(foreground = c), str, Crayon(reset = true))
        (c + 1) % 8 == 0 && println(io)
    end
    print(io, "\n\n")

    println(io, "Color cube, 6×6×6 (16..231):")
    for c in 16:231
        str = codes ? string(lpad(c, 3, '0'), " ") : "██"
        print(io, Crayon(foreground = c), str, Crayon(reset = true))
        (c - 16) %  6 ==  5 && println(io)
        (c - 16) % 36 == 35 && println(io)
    end

    println(io, "Grayscale ramp (232..255):")
    for c in 232:255
        str = codes ? string(lpad(c, 3, '0'), " ") : "██"
        print(io, Crayon(foreground = c), str, Crayon(reset = true))
        (c - 232) %  6 == 5 && println(io)
    end
end

test_24bit_colors(; codes::Bool = true) = test_24bit_colors(stdout, codes)
test_24bit_colors(io::IO) = test_24bit_colors(io, true)
function test_24bit_colors(io::IO, codes::Bool)
    steps = 0:30:255
    for r in steps
        for g in steps
            for b in steps
                str = codes ? string(lpad(r, 3, '0'), "|", lpad(g, 3, '0'), "|", lpad(b, 3, '0'), " ") : "██"
                print(io, Crayon(; foreground = (r, g, b)), str, Crayon(reset = true))
            end
            println(io)
        end
        println(io)
    end
end

function _precompile_()
    ccall(:jl_generating_output, Cint, ()) == 1 || return nothing
    crayon"red"
    print(IOBuffer(), Crayon(foreground = :red), "In red. ", Crayon(bold = true), "Red and bold")
    precompile(Tuple{typeof(Base.print), Base.TTY, Crayons.Crayon})
end

_precompile_()

struct CrayonWrapper
    c::Crayon
    v::Vector{Union{CrayonWrapper,String}}
end

function (c::Crayon)(args::Union{CrayonWrapper,AbstractString}...)
    values = Vector{Union{CrayonWrapper,String}}(undef, length(args))
    for i in eachindex(args)
        arg = args[i]
        values[i] = arg isa CrayonWrapper ? arg : String(arg)
    end
    CrayonWrapper(c, values)
end

Base.show(io::IO, cw::CrayonWrapper) = _show(io, cw, CrayonStack(incremental = true))

_show(io::IO, str::String, stack::CrayonStack) = print(io, str)

function _show(io::IO, cw::CrayonWrapper, stack::CrayonStack)
    print(io, push!(stack, cw.c))
    for obj in cw.v
        _show(io, obj, stack)
    end
    length(stack.crayons) > 1 && print(io, pop!(stack))
    return
end

Base.:*(c::Crayon, cw::CrayonWrapper) = CrayonWrapper(c * cw.c, cw.v)
Base.:*(cw::CrayonWrapper, c::Crayon) = CrayonWrapper(cw.c * c, cw.v)

# Concatenation; the crayon applies to the string it is multiplied with
Base.:*(c::Crayon, s::AbstractString) = c(s)
Base.:*(s::AbstractString, cw::CrayonWrapper) = CrayonWrapper(Crayon(), Union{CrayonWrapper,String}[String(s), cw])
Base.:*(cw::CrayonWrapper, s::AbstractString) = CrayonWrapper(Crayon(), Union{CrayonWrapper,String}[cw, String(s)])
Base.:*(a::CrayonWrapper, b::CrayonWrapper) = CrayonWrapper(Crayon(), Union{CrayonWrapper,String}[a, b])

const FORCE_COLOR = Ref(false)
const FORCE_256_COLORS = Ref(false)
const FORCE_SYSTEM_COLORS = Ref(false)

# The environment is read once at load time; use the force_* functions to
# change the behavior at runtime.
function __init__()
    FORCE_COLOR[]         = haskey(ENV, "FORCE_COLOR")
    FORCE_256_COLORS[]    = haskey(ENV, "FORCE_256_COLORS")
    FORCE_SYSTEM_COLORS[] = haskey(ENV, "FORCE_SYSTEM_COLORS")
end

force_color(b::Bool)         = FORCE_COLOR[]         = b
force_256_colors(b::Bool)    = FORCE_256_COLORS[]    = b
force_system_colors(b::Bool) = FORCE_SYSTEM_COLORS[] = b

_force_color()         = FORCE_COLOR[]
_force_256_colors()    = FORCE_256_COLORS[]
_force_system_colors() = FORCE_SYSTEM_COLORS[]

const CSI = "\e["
const ESCAPED_CSI = "\\e["
const END_ANSI = "m"

# Every number in an escape sequence is in 0:255, so print them via a lookup
# table instead of allocating a string per integer.
const DEC_STRINGS = [string(i) for i in 0:255]
_dec(x::Integer) = DEC_STRINGS[Int(x) + 1]

# Add 30 to get fg ANSI
# Add 40 to get bg ANSI
const COLORS = Dict(
    :black         => 0,
    :red           => 1,
    :green         => 2,
    :yellow        => 3,
    :blue          => 4,
    :magenta       => 5,
    :cyan          => 6,
    :light_gray    => 7,
    :default       => 9,
    :dark_gray     => 60,
    :light_red     => 61,
    :light_green   => 62,
    :light_yellow  => 63,
    :light_blue    => 64,
    :light_magenta => 65,
    :light_cyan    => 66,
    :white         => 67
)

@enum(ColorMode,
RESET,
COLORS_16,
COLORS_256,
COLORS_24BIT)

struct ANSIColor
    r::UInt8 # [0-9, 60-69] for 16 colors, 0-255 for 256 colors
    g::UInt8
    b::UInt8
    style::ColorMode
    active::Bool
end

ANSIColor(r, g, b, style::ColorMode=COLORS_16, active=true) = ANSIColor(UInt8(r), UInt8(g), UInt8(b), style, active)
ANSIColor() = ANSIColor(0x0, 0x0, 0x0, COLORS_16, false)
ANSIColor(val::Integer, style::ColorMode, active::Bool = true) = ANSIColor(UInt8(val), 0, 0, style, active)

red(x::ANSIColor) = x.r
green(x::ANSIColor) = x.g
blue(x::ANSIColor) = x.b
val(x::ANSIColor) = x.r

# The inverse sets the color to default.
# No point making active if color already is default
Base.inv(x::ANSIColor) = ANSIColor(0x9, 0x0, 0x0, COLORS_16, x.active && !(x.style == COLORS_16 && x.r == 9))

struct ANSIStyle
    on::Bool
    active::Bool
end

ANSIStyle() = ANSIStyle(false, false)
ANSIStyle(v::Bool) = ANSIStyle(v, true)

# The inverse always sets the thing to false
# No point in setting active if the style is off.
Base.inv(x::ANSIStyle) = ANSIStyle(false, x.active && x.on)

struct Crayon
    fg::ANSIColor
    bg::ANSIColor

    reset::ANSIStyle
    bold::ANSIStyle
    faint::ANSIStyle
    italics::ANSIStyle
    underline::ANSIStyle
    blink::ANSIStyle
    negative::ANSIStyle
    conceal::ANSIStyle
    strikethrough::ANSIStyle
end

anyactive(x::Crayon) = ((x.reset.active && x.reset.on) ||
                        x.fg.active    || x.bg.active       || x.bold.active      ||
                        x.faint.active || x.italics.active  || x.underline.active ||
                        x.blink.active || x.negative.active || x.conceal.active   || x.strikethrough.active)

Base.inv(c::Crayon) = Crayon(inv(c.fg), inv(c.bg), ANSIStyle(), # no point taking inverse of reset,
                             inv(c.bold), inv(c.faint), inv(c.italics), inv(c.underline),
                             inv(c.blink), inv(c.negative), inv(c.conceal), inv(c.strikethrough))

_have_color() = Base.get_have_color()
_have_color(io::IO) = get(io, :color, _have_color())
_use_color(io::IO) = _have_color(io) || _force_color()

function _downcast(x::Crayon)
    if x.fg.style != COLORS_16 || x.bg.style != COLORS_16
        if _force_system_colors()
            return to_system_colors(x)
        elseif _force_256_colors() && (x.fg.style == COLORS_24BIT || x.bg.style == COLORS_24BIT)
            return to_256_colors(x)
        end
    end
    return x
end

function Base.print(io::IO, x::Crayon)
    if anyactive(x) && _use_color(io)
        x = _downcast(x)
        if io isa Base.GenericIOBuffer
            print(io, CSI)
            _print(io, x)
            print(io, END_ANSI)
        else
            # Assemble the escape sequence and emit it as a single write so it
            # cannot be torn by concurrent writers to the same stream.
            buf = IOBuffer(sizehint = 64)
            print(buf, CSI)
            _print(buf, x)
            print(buf, END_ANSI)
            write(io, take!(buf))
        end
    end
    return nothing
end

function Base.show(io::IO, x::Crayon)
    if anyactive(x)
        color = _use_color(io)
        color && print(io, x)
        print(io, ESCAPED_CSI)
        _print(io, x)
        print(io, END_ANSI)
        color && print(io, CSI, "0", END_ANSI)
    end
end

function _torgb(hex::UInt32)::NTuple{3, UInt8}
    hex <= 0x00ffffff || throw(ArgumentError("RGB color must be between 0x000000 and 0xffffff"))
    (hex << 8 >> 24, hex << 16 >> 24, hex << 24 >> 24)
end

function _parse_color(c::Union{Integer,Symbol,NTuple{3,Integer},UInt32,Nothing})
    ansicol = ANSIColor()
    if c !== nothing
        if c isa Symbol
            haskey(COLORS, c) || throw(ArgumentError("unknown color: $c"))
            ansicol = ANSIColor(COLORS[c], COLORS_16)
        elseif c isa UInt32
            r, g, b = _torgb(c)
            ansicol = ANSIColor(r, g, b, COLORS_24BIT)
        elseif c isa Integer
            0 <= c <= 255 || throw(ArgumentError("256-color index must be between 0 and 255"))
            ansicol = ANSIColor(c, COLORS_256)
        elseif c isa NTuple{3,Integer}
            all(x -> 0 <= x <= 255, c) || throw(ArgumentError("RGB channels must be between 0 and 255"))
            ansicol = ANSIColor(c[1], c[2], c[3], COLORS_24BIT)
        else
            error("should not happen")
        end
    end
    return ansicol
end

function Crayon(;foreground::Union{Integer,Symbol,NTuple{3,Integer},Nothing} = nothing,
                 background::Union{Integer,Symbol,NTuple{3,Integer},Nothing} = nothing,
                 reset::Union{Bool,Nothing} = nothing,
                 bold::Union{Bool,Nothing} = nothing,
                 faint::Union{Bool,Nothing} = nothing,
                 italics::Union{Bool,Nothing} = nothing,
                 underline::Union{Bool,Nothing} = nothing,
                 blink::Union{Bool,Nothing} = nothing,
                 negative::Union{Bool,Nothing} = nothing,
                 conceal::Union{Bool,Nothing} = nothing,
                 strikethrough::Union{Bool,Nothing} = nothing)

    fgcol = _parse_color(foreground)
    bgcol = _parse_color(background)

    _reset         = ANSIStyle()
    _bold          = ANSIStyle()
    _faint         = ANSIStyle()
    _italics       = ANSIStyle()
    _underline     = ANSIStyle()
    _blink         = ANSIStyle()
    _negative      = ANSIStyle()
    _conceal       = ANSIStyle()
    _strikethrough = ANSIStyle()

    reset         !== nothing && (_reset         = ANSIStyle(reset))
    bold          !== nothing && (_bold          = ANSIStyle(bold))
    faint         !== nothing && (_faint         = ANSIStyle(faint))
    italics       !== nothing && (_italics       = ANSIStyle(italics))
    underline     !== nothing && (_underline     = ANSIStyle(underline))
    blink         !== nothing && (_blink         = ANSIStyle(blink))
    negative      !== nothing && (_negative      = ANSIStyle(negative))
    conceal       !== nothing && (_conceal       = ANSIStyle(conceal))
    strikethrough !== nothing && (_strikethrough = ANSIStyle(strikethrough))

    return Crayon(fgcol,
                  bgcol,
                  _reset,
                  _bold,
                  _faint,
                  _italics,
                  _underline,
                  _blink,
                  _negative,
                  _conceal,
                  _strikethrough)
end

# Prints the crayon without the inital and terminating ansi escape sequences
function _print(io::IO, c::Crayon)
    first_active = true
    if c.reset.active && c.reset.on
        first_active = false
        print(io, "0")
    end

    for (col, num) in ((c.fg, 30),
                       (c.bg, 40))
        if col.active
            !first_active && print(io, ";")
            first_active = false

            if col.style == COLORS_16
                print(io, _dec(val(col) + num))
            elseif col.style == COLORS_256
                print(io, num == 30 ? "38;5;" : "48;5;", _dec(val(col)))
            elseif col.style == COLORS_24BIT
                print(io, num == 30 ? "38;2;" : "48;2;", _dec(red(col)), ";", _dec(green(col)), ";", _dec(blue(col)))
            end
        end
    end

    for (style, code) in ((c.bold, 1),
                          (c.faint, 2),
                          (c.italics, 3),
                          (c.underline, 4),
                          (c.blink, 5),
                          (c.negative, 7),
                          (c.conceal, 8),
                          (c.strikethrough, 9))

        if style.active
            !first_active && print(io, ";")
            first_active = false

            # Bold off is actually 22 so special case for code == 1
            print(io, style.on ? _dec(code) : _dec(code == 1 ? 22 : code + 20))
        end
    end
    return nothing
end

function Base.merge(a::Crayon, b::Crayon)
    base = b.reset.active && b.reset.on ? Crayon() : a
    fg            = b.fg.active            ? b.fg            : base.fg
    bg            = b.bg.active            ? b.bg            : base.bg
    reset         = b.reset.active         ? b.reset         : base.reset
    bold          = b.bold.active          ? b.bold          : base.bold
    faint         = b.faint.active         ? b.faint         : base.faint
    italics       = b.italics.active       ? b.italics       : base.italics
    underline     = b.underline.active     ? b.underline     : base.underline
    blink         = b.blink.active         ? b.blink         : base.blink
    negative      = b.negative.active      ? b.negative      : base.negative
    conceal       = b.conceal.active       ? b.conceal       : base.conceal
    strikethrough = b.strikethrough.active ? b.strikethrough : base.strikethrough

    return Crayon(fg,
                  bg,
                  reset,
                  bold,
                  faint,
                  italics,
                  underline,
                  blink,
                  negative,
                  conceal,
                  strikethrough)
end

Base.:*(a::Crayon, b::Crayon) = merge(a, b)

function Base.merge(tok::Crayon, toks::Crayon...)
    for tok2 in toks
        tok = merge(tok, tok2)
    end
    return tok
end

function to_256_colors(crayon::Crayon)
    fg = crayon.fg
    bg = crayon.bg
    crayon.fg.style == COLORS_24BIT && (fg = to_256_colors(crayon.fg))
    crayon.bg.style == COLORS_24BIT && (bg = to_256_colors(crayon.bg))
    return Crayon(
        fg,
        bg,
        crayon.reset,
        crayon.bold,
        crayon.faint,
        crayon.italics,
        crayon.underline,
        crayon.blink,
        crayon.negative,
        crayon.conceal,
        crayon.strikethrough,
    )
end

function to_256_colors(color::ANSIColor)
    @assert color.style == COLORS_24BIT
    r, g, b = color.r, color.g, color.b

    for i in 0:7
        (r, g, b) == SYSTEM_COLOR_RGB[i + 1] && return ANSIColor(UInt8(i), COLORS_256, color.active)
    end

    r6, g6, b6 = _cube_level(r), _cube_level(g), _cube_level(b)
    cube = 16 + 36r6 + 6g6 + b6
    cube_rgb = (COLOR_CUBE_LEVELS[r6 + 1], COLOR_CUBE_LEVELS[g6 + 1], COLOR_CUBE_LEVELS[b6 + 1])

    gray_level = clamp(round(Int, (Int(r) + Int(g) + Int(b) - 24) / 30), 0, 23)
    gray = 8 + 10gray_level
    ansi = if _color_distance((r, g, b), (gray, gray, gray)) < _color_distance((r, g, b), cube_rgb)
        232 + gray_level
    else
        cube
    end
    return ANSIColor(UInt8(ansi), COLORS_256, color.active)
end

# 24bit -> 16 system colors
function to_system_colors(crayon::Crayon)
    fg = crayon.fg
    bg = crayon.bg
    crayon.fg.style in (COLORS_24BIT, COLORS_256) && (fg = to_system_colors(crayon.fg))
    crayon.bg.style in (COLORS_24BIT, COLORS_256) && (bg = to_system_colors(crayon.bg))
    return Crayon(
        fg,
        bg,
        crayon.reset,
        crayon.bold,
        crayon.faint,
        crayon.italics,
        crayon.underline,
        crayon.blink,
        crayon.negative,
        crayon.conceal,
        crayon.strikethrough,
    )
end

const COLOR_CUBE_LEVELS = (0, 95, 135, 175, 215, 255)
const SYSTEM_COLOR_RGB = (
    (0x00, 0x00, 0x00), (0x80, 0x00, 0x00), (0x00, 0x80, 0x00), (0x80, 0x80, 0x00),
    (0x00, 0x00, 0x80), (0x80, 0x00, 0x80), (0x00, 0x80, 0x80), (0xc0, 0xc0, 0xc0),
    (0x80, 0x80, 0x80), (0xff, 0x00, 0x00), (0x00, 0xff, 0x00), (0xff, 0xff, 0x00),
    (0x00, 0x00, 0xff), (0xff, 0x00, 0xff), (0x00, 0xff, 0xff), (0xff, 0xff, 0xff),
)

_cube_level(c) = c < 48 ? 0 : c < 115 ? 1 : min((Int(c) - 35) ÷ 40, 5)

function _color_distance(a, b)
    sum((Int(a[i]) - Int(b[i]))^2 for i in 1:3)
end

function _ansi256_rgb(value::UInt8)
    index = Int(value)
    index < 16 && return SYSTEM_COLOR_RGB[index + 1]
    if index < 232
        index -= 16
        return (COLOR_CUBE_LEVELS[index ÷ 36 + 1],
                COLOR_CUBE_LEVELS[index % 36 ÷ 6 + 1],
                COLOR_CUBE_LEVELS[index % 6 + 1])
    end
    gray = 8 + 10(index - 232)
    return (gray, gray, gray)
end

function to_system_colors(color::ANSIColor)
    @assert color.style in (COLORS_24BIT, COLORS_256)
    rgb = color.style == COLORS_24BIT ? (color.r, color.g, color.b) : _ansi256_rgb(color.r)
    ansi = 0
    distance = typemax(Int)
    for (i, candidate) in enumerate(SYSTEM_COLOR_RGB)
        candidate_distance = _color_distance(rgb, candidate)
        if candidate_distance < distance
            ansi = i <= 8 ? i - 1 : i + 51
            distance = candidate_distance
        end
    end
    return ANSIColor(UInt8(ansi), COLORS_16, color.active)
end

# Type for pushing and popping text states
struct CrayonStack
    incremental::Bool
    crayons::Vector{Crayon}
end

Base.print(io::IO, cs::CrayonStack) = print(io, cs.crayons[end])

function _default_crayon(active::Bool)
    Crayon(ANSIColor(0x9, COLORS_16, active),
           ANSIColor(0x9, COLORS_16, active),
           (ANSIStyle(false, active) for _ in 1:9)...)
end

function CrayonStack(; incremental::Bool = false)
    CrayonStack(incremental, [_default_crayon(!incremental)])
end

# Checks if equal disregarding active or not
_equal(a::ANSIColor, b::ANSIColor) = a.r == b.r && a.g == b.g && a.b == b.b && a.style == b.style
_equal(a::ANSIStyle, b::ANSIStyle) = a.on == b.on


# Currently we have the crayon a on the stack.
# We now want to push the crayon b.
# If in incremental mode we compute the changes needed to achive the state of b.
function _incremental_add(a::ANSIColor, b::ANSIColor, incremental::Bool)
    if b.active
        return ANSIColor(b.r, b.g, b.b, b.style, !_equal(a, b) || !incremental)
    else
        return ANSIColor(a.r, a.g, a.b, a.style, !incremental)
    end
end

# Similar to above
_incremental_add(a::ANSIStyle, b::ANSIStyle, incremental::Bool) = b.active ? ANSIStyle(b.on, !_equal(a, b) || !incremental) : ANSIStyle(a.on, !incremental)

# Have a, going to b
# State should be exactly as b!
# However, we only want to activate those that are needed, that is
# those that are active in a AND are different from b
_incremental_sub(a::ANSIColor, b::ANSIColor, incremental::Bool) = ANSIColor(b.r, b.g, b.b, b.style, !_equal(a, b) || !incremental)
_incremental_sub(a::ANSIStyle, b::ANSIStyle, incremental::Bool) = ANSIStyle(b.on, !_equal(a, b) || !incremental)


function Base.push!(cs::CrayonStack, c::Crayon)
    pc = cs.crayons[end]
    c.reset.active && c.reset.on && (pc = _default_crayon(false))
    push!(cs.crayons, Crayon(
        _incremental_add(pc.fg           , c.fg           , cs.incremental),
        _incremental_add(pc.bg           , c.bg           , cs.incremental),
        _incremental_add(pc.reset        , c.reset        , cs.incremental),
        _incremental_add(pc.bold         , c.bold         , cs.incremental),
        _incremental_add(pc.faint        , c.faint        , cs.incremental),
        _incremental_add(pc.italics      , c.italics      , cs.incremental),
        _incremental_add(pc.underline    , c.underline    , cs.incremental),
        _incremental_add(pc.blink        , c.blink        , cs.incremental),
        _incremental_add(pc.negative     , c.negative     , cs.incremental),
        _incremental_add(pc.conceal      , c.conceal      , cs.incremental),
        _incremental_add(pc.strikethrough, c.strikethrough, cs.incremental)))
    return cs
end

function Base.pop!(cs::CrayonStack)
    length(cs.crayons) == 1 && throw(ArgumentError("no more Crayons left in stack"))

    c = pop!(cs.crayons)
    pc = cs.crayons[end]
    if length(cs.crayons) == 1
        pc = _default_crayon(true)
    end
    cs.crayons[end] = Crayon(
        _incremental_sub(c.fg           , pc.fg           , cs.incremental),
        _incremental_sub(c.bg           , pc.bg           , cs.incremental),
        _incremental_sub(c.reset        , pc.reset        , cs.incremental),
        _incremental_sub(c.bold         , pc.bold         , cs.incremental),
        _incremental_sub(c.faint        , pc.faint        , cs.incremental),
        _incremental_sub(c.italics      , pc.italics      , cs.incremental),
        _incremental_sub(c.underline    , pc.underline    , cs.incremental),
        _incremental_sub(c.blink        , pc.blink        , cs.incremental),
        _incremental_sub(c.negative     , pc.negative     , cs.incremental),
        _incremental_sub(c.conceal      , pc.conceal      , cs.incremental),
        _incremental_sub(c.strikethrough, pc.strikethrough, cs.incremental))
    # Return the currently active crayon so we can use print(pop!(crayonstack), "bla")
    return cs
end

using Crayons
using Crayons.Box
using Test

Crayons.force_color(true)

Crayons.print_logo()
Crayons.test_system_colors(IOBuffer())
Crayons.test_24bit_colors(IOBuffer())
Crayons.test_256_colors(IOBuffer())

@testset "styles" begin
    @test string(Crayon(bold = true)) == "\e[1m"
    @test string(Crayon(bold = false)) == "\e[22m"
    @test string(Crayon(underline = true)) == "\e[4m"
    @test string(Crayon(underline = false)) == "\e[24m"
    @test string(Crayon(bold = true, underline = false)) == "\e[1;24m"
    @test string(Crayon(italics = false)) == "\e[23m"
    @test string(Crayon(italics = true, underline = false)) == "\e[3;24m"
    @test string(Crayon(faint = true)) == "\e[2m"
    @test string(Crayon(conceal = true)) == "\e[8m"
    @test string(Crayon(faint = false)) == "\e[22m"
    @test string(Crayon(conceal = false)) == "\e[28m"
    @test string(Crayon(strikethrough = true)) == "\e[9m"
    @test string(Crayon(blink = true)) == "\e[5m"
    @test string(Crayon(strikethrough = false)) == "\e[29m"
    @test string(Crayon(blink = false)) == "\e[25m"
    @test string(Crayon(negative = true)) == "\e[7m"
    @test string(Crayon(negative = false)) == "\e[27m"
    @test string(Crayon(reset = true)) == "\e[0m"
    @test string(Crayon(reset = false)) == ""
    @test string(Crayon()) == ""
end

@testset "IO color context" begin
    Crayons.force_color(false)
    c = Crayon(foreground = :red)
    @test sprint(print, c; context = :color => true) == "\e[31m"
    @test sprint(print, c; context = :color => false) == ""
    @test sprint(show, c; context = :color => false) == "\\e[31m"
    @test !occursin('\e', sprint(show, c; context = :color => false))
    Crayons.force_color(true)
end

@testset "16 colors" begin
    @test string(Crayon(foreground = :red)) == "\e[31m"
    @test string(Crayon(background = :green)) == "\e[42m"
    @test string(Crayon(foreground = :red, background = :green)) == "\e[31;42m"
    @test string(Crayon(foreground = :red, bold = true)) == "\e[31;1m"
    @test string(Crayon(foreground = :default, background = :default)) == "\e[39;49m"
end

@testset "256 colors" begin
    @test string(Crayon(foreground = 32)) == "\e[38;5;32m"
    @test string(Crayon(foreground = 32, bold = true)) == "\e[38;5;32;1m"
    @test string(Crayon(foreground = 32, background = 15, bold = true)) == "\e[38;5;32;48;5;15;1m"
end

@testset "24 bit colors" begin
    @test string(Crayon(foreground = (100,150,200))) == "\e[38;2;100;150;200m"
    @test string(Crayon(foreground = (100,150,200), background = (200,210,220))) == "\e[38;2;100;150;200;48;2;200;210;220m"
    @test string(Crayon(foreground = (100,150,200), background = (200,210,220), bold = true)) == "\e[38;2;100;150;200;48;2;200;210;220;1m"
end

@testset "mixing color modes" begin
    @test string(Crayon(foreground = :red, background = (10,20,30))) == "\e[31;48;2;10;20;30m"
    @test string(Crayon(foreground = :60, background = (10,20,30))) == "\e[38;5;60;48;2;10;20;30m"
end

@testset "hex colors" begin
    @test string(Crayon(foreground = 0x000000)) ==  string(Crayon(foreground = (0,0,0)))
    @test string(Crayon(foreground = 0xffffff)) ==  string(Crayon(foreground = (255,255,255)))
    @test string(Crayon(foreground = 0xffaadd)) ==  string(Crayon(foreground = (255,170,221)))
end

@testset "string macro" begin
    @test string(crayon"0xffffff") == string(Crayon(foreground = 0xffffff))
    @test string(crayon"ffffff") == string(Crayon(foreground = 0xffffff))
    @test string(crayon"#ffffff") == string(Crayon(foreground = 0xffffff))
    @test string(crayon"fg:0xffffff") == string(Crayon(foreground = 0xffffff))
    @test string(crayon"bg:0xff00ff fg:0xffffff") == string(Crayon(foreground = 0xffffff, background = 0xff00ff))
    @test string(crayon"bg:red bold !underline") == string(Crayon(background = :red, bold = true, underline = false))
    @test string(crayon"bg:(1,2,3) fg:(2,1,5)") == string(Crayon(background = (1,2,3), foreground = (2,1,5)))
    @test string(crayon"ABCDEF") == string(Crayon(foreground = 0xabcdef))
    @test string(crayon"") == ""
    @test string(Crayons.@crayon_str("bold\tred")) == string(Crayon(foreground = :red, bold = true))

    for token in ("1234567", "0x1234567", "(1,2,3)junk", "x(1,2,3)", "(,,)", "256", "-1")
        @test_throws ArgumentError Crayons._parse_color_string(token)
    end
end

@testset "constructor validation" begin
    @test Crayon(foreground = Int8(1)) == Crayon(foreground = 1)
    @test Crayon(foreground = UInt8(1)) == Crayon(foreground = 1)
    @test Crayon(foreground = BigInt(1)) == Crayon(foreground = 1)
    @test_throws ArgumentError Crayon(foreground = 256)
    @test_throws ArgumentError Crayon(foreground = -1)
    @test_throws ArgumentError Crayon(foreground = (0, 0, 256))
    @test_throws ArgumentError Crayon(foreground = (-1, 0, 0))
    @test_throws ArgumentError Crayon(foreground = UInt32(0x01000000))
    @test_throws ArgumentError Crayon(foreground = :unknown)
end

@testset "force 256 colors" begin
    Crayons.force_256_colors(true)
    @test string(crayon"(0,0,255)") == string(Crayon(foreground = 21))
    @test string(crayon"fg:(0,0,255) bg:(255,0,255)") == string(Crayon(foreground = 21, background = 201))
    Crayons.force_256_colors(false)
end

@testset "force system colors" begin
    Crayons.force_system_colors(true)
    @test string(Crayon(foreground = 208)) == string(Crayon(foreground = :light_yellow))
    @test string(Crayon(foreground = (255, 135, 0))) == string(Crayon(foreground = :light_yellow))
    @test string(Crayon(foreground = (255, 135, 0), background = 21)) ==
          string(Crayon(foreground = :light_yellow, background = :light_blue))

    # system colors take precedence over 256 colors
    Crayons.force_256_colors(true)
    @test string(Crayon(foreground = (255, 135, 0))) == string(Crayon(foreground = :light_yellow))
    Crayons.force_256_colors(false)
    Crayons.force_system_colors(false)
end

@testset "CrayonStack" begin
    cs = CrayonStack()
    @test string(cs) == string(Crayon(foreground = :default, background = :default, bold = false, italics = false, underline = false, strikethrough = false, blink = false, conceal = false, negative = false, faint = false))
    push!(cs, Crayon(foreground = :red))
    @test string(cs) == string(Crayon(foreground = :red, background = :default, bold = false, italics = false, underline = false, strikethrough = false, blink = false, conceal = false, negative = false, faint = false))
    push!(cs, Crayon(foreground = :green))
    @test string(cs) == string(Crayon(foreground = :green, background = :default, bold = false, italics = false, underline = false, strikethrough = false, blink = false, conceal = false, negative = false, faint = false))
    push!(cs, Crayon(bold = true, background = 125))
    @test string(cs) == string(Crayon(foreground = :green, background = 125, bold = true, italics = false, underline = false, strikethrough = false, blink = false, conceal = false, negative = false, faint = false))
    push!(cs, Crayon(bold = false))
    @test string(cs) == string(Crayon(foreground = :green, background = 125, bold = false, italics = false, underline = false, strikethrough = false, blink = false, conceal = false, negative = false, faint = false))
    pop!(cs) # Popping the bold = false
    @test string(cs) == string(Crayon(foreground = :green, background = 125, bold = true, italics = false, underline = false, strikethrough = false, blink = false, conceal = false, negative = false, faint = false))
    pop!(cs) # Popping the bold = true + background = 125
    @test string(cs) == string(Crayon(foreground = :green, background = :default, bold = false, italics = false, underline = false, strikethrough = false, blink = false, conceal = false, negative = false, faint = false))
    pop!(cs) # Popping the foreground = :green
    @test string(cs) == string(Crayon(foreground = :red, background = :default, bold = false, italics = false, underline = false, strikethrough = false, blink = false, conceal = false, negative = false, faint = false))
    pop!(cs) # Popping the foreground = :red
    @test string(cs) == string(Crayon(foreground = :default, background = :default, bold = false, italics = false, underline = false, strikethrough = false, blink = false, conceal = false, negative = false, faint = false))
    @test_throws ArgumentError pop!(cs)

    reset_stack = CrayonStack()
    push!(reset_stack, Crayon(foreground = :red))
    push!(reset_stack, Crayon(reset = true))
    @test string(reset_stack) == string(Crayon(foreground = :default, background = :default, reset = true, bold = false, italics = false, underline = false, strikethrough = false, blink = false, conceal = false, negative = false, faint = false))
    pop!(reset_stack)
    @test string(reset_stack) == string(Crayon(foreground = :red, background = :default, bold = false, italics = false, underline = false, strikethrough = false, blink = false, conceal = false, negative = false, faint = false))
end

@testset "incremental mode CrayonStack" begin
    cs = CrayonStack(incremental = true) # State:
    push!(cs, Crayon(foreground = :red)) # State: fg = red, change: fg = red
    @test string(cs) == string(Crayon(foreground = :red))
    push!(cs, Crayon(foreground = :red)) # State: fg = red, change:
    @test string(cs) == ""
    push!(cs, Crayon(foreground = :blue)) # State: fg = blue, change: fg = blue
    @test string(cs) == string(Crayon(foreground = :blue))
    push!(cs, Crayon(bold = true)) # State fg = blue, bold = true, change: bold = true
    @test string(cs) == string(Crayon(bold = true))
    pop!(cs) # State fg = blue, change: bold = false
    @test string(cs) == string(Crayon(bold = false))
    pop!(cs) # State fg = red, change: fg = red
    @test string(cs) == string(Crayon(foreground = :red))
    pop!(cs) # State fg = red, change:
    @test string(cs) == ""
    pop!(cs) # State change: fg = default
    @test string(cs) == string(Crayon(foreground = :default))

    reset = Crayon(reset = true)
    push!(cs, Crayon(foreground = :red))
    @test string(cs) == string(Crayon(foreground = :red))
    push!(cs, reset)
    @test string(cs) == string(reset)
    pop!(cs)
    @test string(cs) == string(Crayon(foreground = :red))
end

@testset "merge" begin
    @test string(merge(Crayon(foreground = :blue, background = :red))) == string(Crayon(foreground = :blue, background = :red))
    @test string(merge(Crayon(foreground = :blue), Crayon(background = :red)))  == string(Crayon(foreground = :blue, background = :red))
    @test string(merge(Crayon(foreground = :blue), Crayon(background = :red), Crayon(bold = true))) == string(Crayon(foreground = :blue, background = :red, bold = true))
    @test string(merge(Crayon(foreground = :red), Crayon(foreground = :blue))) == string(Crayon(foreground = :blue))
    @test string(merge(Crayon(foreground = :red), Crayon(negative = true))) == string(Crayon(foreground = :red, negative = true))
    @test string(BLACK_BG * WHITE_FG * BOLD) == string(Crayon(foreground = :white, background = :black, bold = true))
    @test string(merge(Crayon(foreground = :red, bold = true), Crayon(reset = true))) == string(Crayon(reset = true))
    @test string(merge(Crayon(foreground = :red), Crayon(reset = true, underline = true))) ==
          string(Crayon(reset = true, underline = true))
end

@testset "call overloading" begin
    @test string(Crayon()("hello")) == "hello"
    @test string(Crayon()(split("hello world")[1])) == "hello" # test substrings
    @test string(Crayon(bold=true)("hello")) == string(BOLD, "hello", inv(BOLD))
    @test string(Crayon(bold=true, foreground = :red)("hello")) == string(Crayon(foreground=:red, bold=true), "hello", Crayon(foreground=:default, bold=false))

    @test string("normal", BOLD("bold", RED_FG("red bold", UNDERLINE("red_underline"), "red bold"), "bold"), "normal" ) ==
        string("normal", BOLD, "bold", RED_FG, "red bold", UNDERLINE, "red_underline", inv(UNDERLINE), "red bold", inv(RED_FG), "bold", inv(BOLD), "normal")

    @test string("normal", BOLD*UNDERLINE("bold_underline", ITALICS*RED_FG("everything"), "bold_underline"), "normal") ==
        string("normal", Crayon(bold=true, underline=true),"bold_underline", Crayon(italics=true, foreground=:red), "everything", Crayon(italics=false, foreground=:default),
         "bold_underline", Crayon(bold=false, underline=false), "normal")

    reset = Crayon(reset = true)
    @test string(RED_FG("a", reset("b"), "c")) ==
          string(RED_FG, "a", reset, "b", RED_FG, "c", inv(RED_FG))
end

@testset "Box RESET" begin
    @test RESET === Crayon(reset = true)
    @test string(RESET) == "\e[0m"
end

@testset "string concatenation" begin
    @test string(RED_FG * "red") == string(RED_FG("red"))
    @test string("a " * RED_FG("red")) == string("a ", RED_FG, "red", inv(RED_FG))
    @test string(RED_FG("red") * " b") == string(RED_FG, "red", inv(RED_FG), " b")
    @test string(RED_FG("red") * BLUE_FG("blue")) ==
          string(RED_FG, "red", inv(RED_FG), BLUE_FG, "blue", inv(BLUE_FG))
    @test string(RED_FG * "red " * BLUE_FG("blue") * " normal") ==
          string(RED_FG, "red ", inv(RED_FG), BLUE_FG, "blue", inv(BLUE_FG), " normal")
end

@testset "8bit - 256 colors" begin
    # en.wikipedia.org/wiki/ANSI_escape_code#8-bit

    # Standard colors (primary colors): 0 - 15
    @test crayon"000000" |> Crayons.to_256_colors == crayon"0"
    @test crayon"800000" |> Crayons.to_256_colors == crayon"1"
    @test crayon"008000" |> Crayons.to_256_colors == crayon"2"
    @test crayon"808000" |> Crayons.to_256_colors == crayon"3"
    @test crayon"000080" |> Crayons.to_256_colors == crayon"4"
    @test crayon"800080" |> Crayons.to_256_colors == crayon"5"
    @test crayon"008080" |> Crayons.to_256_colors == crayon"6"
    @test crayon"c0c0c0" |> Crayons.to_256_colors == crayon"7"
    # High-intensity colors are all duplicates from the cube or gray levels
    @test crayon"808080" |> Crayons.to_256_colors != crayon"8"  # 240
    @test crayon"ff0000" |> Crayons.to_256_colors != crayon"9"  # 196
    @test crayon"00ff00" |> Crayons.to_256_colors != crayon"10"  # 46
    @test crayon"ffff00" |> Crayons.to_256_colors != crayon"11"  # 226
    @test crayon"0000ff" |> Crayons.to_256_colors != crayon"12"  # 21
    @test crayon"ff00ff" |> Crayons.to_256_colors != crayon"13"  # 201
    @test crayon"00ffff" |> Crayons.to_256_colors != crayon"14"  # 51
    @test crayon"ffffff" |> Crayons.to_256_colors != crayon"15"  # 231

    # 6x6x6 cube: 16 - 231
    foregroundCrayon(fgcol) = Crayon(fgcol, Crayons.ANSIColor(), (Crayons.ANSIStyle() for _ in 1:9)...)
    UInt8tohex(s) = string(s, base=16, pad=2)

    levels = [0, 95, 135, 175, 215, 255]
    for (k, lk) in enumerate(levels), (j, lj) in enumerate(levels), (i, li) in enumerate(levels)
        i == 1 && j == 1 && k == 1 && continue  # ansi 16 is a duplicate of ansi 0 (tested in primary colors)
        @test (
            UInt8tohex(lk) * UInt8tohex(lj) * UInt8tohex(li) |>
            Crayons._parse_color_string |> foregroundCrayon |> Crayons.to_256_colors ==
            Crayon(foreground = 16 + (k - 1) * length(levels)^2 + (j - 1) * length(levels) + (i - 1))
        )
    end

    # gray levels: 232 - 255
    @test crayon"080808" |> Crayons.to_256_colors == crayon"232"
    @test crayon"121212" |> Crayons.to_256_colors == crayon"233"
    @test crayon"1c1c1c" |> Crayons.to_256_colors == crayon"234"
    @test crayon"262626" |> Crayons.to_256_colors == crayon"235"
    @test crayon"303030" |> Crayons.to_256_colors == crayon"236"
    @test crayon"3a3a3a" |> Crayons.to_256_colors == crayon"237"
    @test crayon"444444" |> Crayons.to_256_colors == crayon"238"
    @test crayon"4e4e4e" |> Crayons.to_256_colors == crayon"239"
    @test crayon"585858" |> Crayons.to_256_colors == crayon"240"
    @test crayon"626262" |> Crayons.to_256_colors == crayon"241"
    @test crayon"6c6c6c" |> Crayons.to_256_colors == crayon"242"
    @test crayon"767676" |> Crayons.to_256_colors == crayon"243"
    @test crayon"808080" |> Crayons.to_256_colors == crayon"244"
    @test crayon"8a8a8a" |> Crayons.to_256_colors == crayon"245"
    @test crayon"949494" |> Crayons.to_256_colors == crayon"246"
    @test crayon"9e9e9e" |> Crayons.to_256_colors == crayon"247"
    @test crayon"a8a8a8" |> Crayons.to_256_colors == crayon"248"
    @test crayon"b2b2b2" |> Crayons.to_256_colors == crayon"249"
    @test crayon"bcbcbc" |> Crayons.to_256_colors == crayon"250"
    @test crayon"c6c6c6" |> Crayons.to_256_colors == crayon"251"
    @test crayon"d0d0d0" |> Crayons.to_256_colors == crayon"252"
    @test crayon"dadada" |> Crayons.to_256_colors == crayon"253"
    @test crayon"e4e4e4" |> Crayons.to_256_colors == crayon"254"
    @test crayon"eeeeee" |> Crayons.to_256_colors == crayon"255"
    @test crayon"7f7f7f" |> Crayons.to_256_colors == crayon"244"
    @test crayon"f8f8f8" |> Crayons.to_256_colors == crayon"231"
end

@testset "8bit ansi approximation" begin
    # codegolf.stackexchange.com/q/156918
    @test Crayons.to_256_colors(crayon"(95,135,0)") == crayon"64"
    @test Crayons.to_256_colors(crayon"(255,255,255)") == crayon"231"
    @test Crayons.to_256_colors(crayon"(238,238,238)") == crayon"255"
    @test Crayons.to_256_colors(crayon"(90,133,140)") == crayon"66"
    @test Crayons.to_256_colors(crayon"(218,215,216)") == crayon"188"
    @test Crayons.to_256_colors(crayon"(175,0,155)") == crayon"127"
    @test Crayons.to_256_colors(crayon"(115,155,235)") == crayon"111"
    @test Crayons.to_256_colors(crayon"(0,175,95)") == crayon"35"

    # misc (UnicodePlots)
    @test Crayons.to_256_colors(crayon"(255,102,255)") == crayon"207"
    @test Crayons.to_256_colors(crayon"(255,135,0)") == crayon"208"
    @test Crayons.to_256_colors(crayon"(187,0,187)") == crayon"127"
    @test Crayons.to_256_colors(crayon"(50,100,50)") == crayon"238"
    @test Crayons.to_256_colors(crayon"(102,102,0)") == crayon"58"
    @test Crayons.to_256_colors(crayon"(200,50,0)") == crayon"166"
    @test Crayons.to_256_colors(crayon"(0,51,102)") == crayon"23"
    @test Crayons.to_256_colors(crayon"(102,51,0)") == crayon"58"
    @test Crayons.to_256_colors(crayon"(0,204,204)") == crayon"44"
end

@testset "named HTML to 8bit" begin
    # www.w3schools.com/colors/colors_hex.asp
    @test crayon"000000" |> Crayons.to_256_colors == crayon"0"
    @test crayon"000080" |> Crayons.to_256_colors == crayon"4"
    @test crayon"00008b" |> Crayons.to_256_colors == crayon"18"
    @test crayon"0000cd" |> Crayons.to_256_colors == crayon"20"
    @test crayon"0000ff" |> Crayons.to_256_colors == crayon"21"
    @test crayon"006400" |> Crayons.to_256_colors == crayon"22"
    @test crayon"008000" |> Crayons.to_256_colors == crayon"2"
    @test crayon"008080" |> Crayons.to_256_colors == crayon"6"
    @test crayon"008b8b" |> Crayons.to_256_colors == crayon"30"
    @test crayon"00bfff" |> Crayons.to_256_colors == crayon"39"
    @test crayon"00ced1" |> Crayons.to_256_colors == crayon"44"
    @test crayon"00fa9a" |> Crayons.to_256_colors == crayon"48"
    @test crayon"00ff00" |> Crayons.to_256_colors == crayon"46"
    @test crayon"00ff7f" |> Crayons.to_256_colors == crayon"48"
    @test crayon"00ffff" |> Crayons.to_256_colors == crayon"51"
    @test crayon"191970" |> Crayons.to_256_colors == crayon"17"
    @test crayon"1e90ff" |> Crayons.to_256_colors == crayon"33"
    @test crayon"20b2aa" |> Crayons.to_256_colors == crayon"37"
    @test crayon"228b22" |> Crayons.to_256_colors == crayon"28"
    @test crayon"2e8b57" |> Crayons.to_256_colors == crayon"29"
    @test crayon"2f4f4f" |> Crayons.to_256_colors == crayon"238"
    @test crayon"32cd32" |> Crayons.to_256_colors == crayon"77"
    @test crayon"3cb371" |> Crayons.to_256_colors == crayon"71"
    @test crayon"40e0d0" |> Crayons.to_256_colors == crayon"80"
    @test crayon"4169e1" |> Crayons.to_256_colors == crayon"62"
    @test crayon"4682b4" |> Crayons.to_256_colors == crayon"67"
    @test crayon"483d8b" |> Crayons.to_256_colors == crayon"60"
    @test crayon"48d1cc" |> Crayons.to_256_colors == crayon"80"
    @test crayon"4b0082" |> Crayons.to_256_colors == crayon"54"
    @test crayon"556b2f" |> Crayons.to_256_colors == crayon"239"
    @test crayon"5f9ea0" |> Crayons.to_256_colors == crayon"73"
    @test crayon"6495ed" |> Crayons.to_256_colors == crayon"69"
    @test crayon"663399" |> Crayons.to_256_colors == crayon"60"
    @test crayon"66cdaa" |> Crayons.to_256_colors == crayon"79"
    @test crayon"696969" |> Crayons.to_256_colors == crayon"242"
    @test crayon"6a5acd" |> Crayons.to_256_colors == crayon"62"
    @test crayon"6b8e23" |> Crayons.to_256_colors == crayon"64"
    @test crayon"708090" |> Crayons.to_256_colors == crayon"66"
    @test crayon"778899" |> Crayons.to_256_colors == crayon"102"
    @test crayon"7b68ee" |> Crayons.to_256_colors == crayon"99"
    @test crayon"7cfc00" |> Crayons.to_256_colors == crayon"118"
    @test crayon"7fff00" |> Crayons.to_256_colors == crayon"118"
    @test crayon"7fffd4" |> Crayons.to_256_colors == crayon"122"
    @test crayon"800000" |> Crayons.to_256_colors == crayon"1"
    @test crayon"800080" |> Crayons.to_256_colors == crayon"5"
    @test crayon"808000" |> Crayons.to_256_colors == crayon"3"
    @test crayon"808080" |> Crayons.to_256_colors == crayon"244"
    @test crayon"87ceeb" |> Crayons.to_256_colors == crayon"117"
    @test crayon"87cefa" |> Crayons.to_256_colors == crayon"117"
    @test crayon"8a2be2" |> Crayons.to_256_colors == crayon"92"
    @test crayon"8b0000" |> Crayons.to_256_colors == crayon"88"
    @test crayon"8b008b" |> Crayons.to_256_colors == crayon"90"
    @test crayon"8b4513" |> Crayons.to_256_colors == crayon"94"
    @test crayon"8fbc8f" |> Crayons.to_256_colors == crayon"108"
    @test crayon"90ee90" |> Crayons.to_256_colors == crayon"120"
    @test crayon"9370db" |> Crayons.to_256_colors == crayon"98"
    @test crayon"9400d3" |> Crayons.to_256_colors == crayon"92"
    @test crayon"98fb98" |> Crayons.to_256_colors == crayon"120"
    @test crayon"9932cc" |> Crayons.to_256_colors == crayon"98"
    @test crayon"9acd32" |> Crayons.to_256_colors == crayon"113"
    @test crayon"a0522d" |> Crayons.to_256_colors == crayon"130"
    @test crayon"a52a2a" |> Crayons.to_256_colors == crayon"124"
    @test crayon"a9a9a9" |> Crayons.to_256_colors == crayon"248"
    @test crayon"add8e6" |> Crayons.to_256_colors == crayon"152"
    @test crayon"adff2f" |> Crayons.to_256_colors == crayon"154"
    @test crayon"afeeee" |> Crayons.to_256_colors == crayon"159"
    @test crayon"b0c4de" |> Crayons.to_256_colors == crayon"152"
    @test crayon"b0e0e6" |> Crayons.to_256_colors == crayon"152"
    @test crayon"b22222" |> Crayons.to_256_colors == crayon"124"
    @test crayon"b8860b" |> Crayons.to_256_colors == crayon"136"
    @test crayon"ba55d3" |> Crayons.to_256_colors == crayon"134"
    @test crayon"bc8f8f" |> Crayons.to_256_colors == crayon"138"
    @test crayon"bdb76b" |> Crayons.to_256_colors == crayon"143"
    @test crayon"c0c0c0" |> Crayons.to_256_colors == crayon"7"
    @test crayon"c71585" |> Crayons.to_256_colors == crayon"162"
    @test crayon"cd5c5c" |> Crayons.to_256_colors == crayon"167"
    @test crayon"cd853f" |> Crayons.to_256_colors == crayon"173"
    @test crayon"d2691e" |> Crayons.to_256_colors == crayon"166"
    @test crayon"d2b48c" |> Crayons.to_256_colors == crayon"180"
    @test crayon"d3d3d3" |> Crayons.to_256_colors == crayon"252"
    @test crayon"d8bfd8" |> Crayons.to_256_colors == crayon"182"
    @test crayon"da70d6" |> Crayons.to_256_colors == crayon"170"
    @test crayon"daa520" |> Crayons.to_256_colors == crayon"178"
    @test crayon"db7093" |> Crayons.to_256_colors == crayon"168"
    @test crayon"dc143c" |> Crayons.to_256_colors == crayon"161"
    @test crayon"dcdcdc" |> Crayons.to_256_colors == crayon"253"
    @test crayon"dda0dd" |> Crayons.to_256_colors == crayon"182"
    @test crayon"deb887" |> Crayons.to_256_colors == crayon"180"
    @test crayon"e0ffff" |> Crayons.to_256_colors == crayon"195"
    @test crayon"e6e6fa" |> Crayons.to_256_colors == crayon"255"
    @test crayon"e9967a" |> Crayons.to_256_colors == crayon"174"
    @test crayon"ee82ee" |> Crayons.to_256_colors == crayon"213"
    @test crayon"eee8aa" |> Crayons.to_256_colors == crayon"223"
    @test crayon"f08080" |> Crayons.to_256_colors == crayon"210"
    @test crayon"f0e68c" |> Crayons.to_256_colors == crayon"222"
    @test crayon"f0f8ff" |> Crayons.to_256_colors == crayon"231"
    @test crayon"f0fff0" |> Crayons.to_256_colors == crayon"255"
    @test crayon"f0ffff" |> Crayons.to_256_colors == crayon"231"
    @test crayon"f4a460" |> Crayons.to_256_colors == crayon"215"
    @test crayon"f5deb3" |> Crayons.to_256_colors == crayon"223"
    @test crayon"f5f5dc" |> Crayons.to_256_colors == crayon"230"
    @test crayon"f5f5f5" |> Crayons.to_256_colors == crayon"255"
    @test crayon"f5fffa" |> Crayons.to_256_colors == crayon"231"
    @test crayon"f8f8ff" |> Crayons.to_256_colors == crayon"231"
    @test crayon"fa8072" |> Crayons.to_256_colors == crayon"209"
    @test crayon"faebd7" |> Crayons.to_256_colors == crayon"230"
    @test crayon"faf0e6" |> Crayons.to_256_colors == crayon"255"
    @test crayon"fafad2" |> Crayons.to_256_colors == crayon"230"
    @test crayon"fdf5e6" |> Crayons.to_256_colors == crayon"230"
    @test crayon"ff0000" |> Crayons.to_256_colors == crayon"196"
    @test crayon"ff00ff" |> Crayons.to_256_colors == crayon"201"
    @test crayon"ff1493" |> Crayons.to_256_colors == crayon"198"
    @test crayon"ff4500" |> Crayons.to_256_colors == crayon"202"
    @test crayon"ff6347" |> Crayons.to_256_colors == crayon"203"
    @test crayon"ff69b4" |> Crayons.to_256_colors == crayon"205"
    @test crayon"ff7f50" |> Crayons.to_256_colors == crayon"209"
    @test crayon"ff8c00" |> Crayons.to_256_colors == crayon"208"
    @test crayon"ffa07a" |> Crayons.to_256_colors == crayon"216"
    @test crayon"ffa500" |> Crayons.to_256_colors == crayon"214"
    @test crayon"ffb6c1" |> Crayons.to_256_colors == crayon"217"
    @test crayon"ffc0cb" |> Crayons.to_256_colors == crayon"218"
    @test crayon"ffd700" |> Crayons.to_256_colors == crayon"220"
    @test crayon"ffdab9" |> Crayons.to_256_colors == crayon"223"
    @test crayon"ffdead" |> Crayons.to_256_colors == crayon"223"
    @test crayon"ffe4b5" |> Crayons.to_256_colors == crayon"223"
    @test crayon"ffe4c4" |> Crayons.to_256_colors == crayon"224"
    @test crayon"ffe4e1" |> Crayons.to_256_colors == crayon"224"
    @test crayon"ffebcd" |> Crayons.to_256_colors == crayon"230"
    @test crayon"ffefd5" |> Crayons.to_256_colors == crayon"230"
    @test crayon"fff0f5" |> Crayons.to_256_colors == crayon"231"
    @test crayon"fff5ee" |> Crayons.to_256_colors == crayon"255"
    @test crayon"fff8dc" |> Crayons.to_256_colors == crayon"230"
    @test crayon"fffacd" |> Crayons.to_256_colors == crayon"230"
    @test crayon"fffaf0" |> Crayons.to_256_colors == crayon"231"
    @test crayon"fffafa" |> Crayons.to_256_colors == crayon"231"
    @test crayon"ffff00" |> Crayons.to_256_colors == crayon"226"
    @test crayon"ffffe0" |> Crayons.to_256_colors == crayon"230"
    @test crayon"fffff0" |> Crayons.to_256_colors == crayon"231"
    @test crayon"ffffff" |> Crayons.to_256_colors == crayon"231"
end

@testset "4bit" begin
    @test crayon"0000ff" |> Crayons.to_system_colors == Crayon(foreground = :light_blue)
    @test crayon"00ff00" |> Crayons.to_system_colors == Crayon(foreground = :light_green)
    @test crayon"ff0000" |> Crayons.to_system_colors == Crayon(foreground = :light_red)
end

@testset "load-time environment variables" begin
    code = "using Crayons; print(string(Crayon(foreground = :red)))"
    cmd = `$(Base.julia_cmd()) --color=no --startup-file=no --project=$(Base.active_project()) -e $code`
    @test read(addenv(cmd, "FORCE_COLOR" => "1"), String) == "\e[31m"
    env = copy(ENV)
    delete!(env, "FORCE_COLOR")
    @test read(setenv(cmd, env), String) == ""
end

@testset "ambiguities" begin
    @test isempty(Test.detect_ambiguities(Crayons; recursive = true))
end
